# Interface GraphStructureChangeListener

public interface GraphStructureChangeListener
Listener interface for monitoring structural changes to live scene graphs. BranchGroup additions, removals and moves are reported.

Since:
  Java 3D 1.4
See Also:
  - `VirtualUniverse.addGraphStructureChangeListener(GraphStructureChangeListener)`

## Method Summary

Modifier and Type
Method
Description
`void`
`branchGroupAdded(Object parent, BranchGroup child)`
Invoked when a branch group is added.
`void`
`branchGroupMoved(Object oldParent, Object newParent, BranchGroup child)`
Invoked when a branch group is moved.
`void`
`branchGroupRemoved(Object parent, BranchGroup child)`
Invoked when a branch group is removed.

## Method Details

### branchGroupAdded

void branchGroupAdded(Object parent, BranchGroup child)
Invoked when a branch group is added. Called just before the child is added to the parent. Parent can be either a BranchGroup or a Locale.

Parameters:
  `parent` - the parent of the child being added
  `child` - the child being added

### branchGroupRemoved

void branchGroupRemoved(Object parent, BranchGroup child)
Invoked when a branch group is removed. Called just after the child has been removed from the parent. Parent can be either a BranchGroup or a Locale.

Parameters:
  `parent` - the parent of the child being added
  `child` - the child being added

### branchGroupMoved

void branchGroupMoved(Object oldParent, Object newParent, BranchGroup child)
Invoked when a branch group is moved. Called after a child has been moved to it's new parent. This call differs from the other methods in that the child is live when this method is called.

Parameters:
  `oldParent` - the original parent of the child being moved
  `newParent` - the new parent of the child being moved
  `child` - the child being moved